{$IFDEF Windows}
  uses WinCrt;
{$ENDIF}
var
  InfoArray : array[0..255] of word;
  IdeInfo  : record
    Config    : word;
    CylsTotal : word;
    Unused    : word;
    HeadTotal : word;
    BPT       : word;
    BPS       : word;
    SPT       : word;
    Vendor    : array[0..2] of word;
    Serial    : array[1..20] of char;
    BufType   : Word;
    BufSize   : Word;
    ECC       : Word;
    Revision  : array[1..8] of char;
    Model     : array[1..40] of char;
  end absolute InfoArray;
  Count : byte;
  i : byte;
begin
  writeln('ଠ  ᪮ IDE:'^M^J);
{$IFDEF WINDOWS}
  for count := 1 to mem[  $0040:$0075] do begin
{$ELSE}
  for count := 1 to mem[Seg0040:$0075] do begin
{$ENDIF}
    FillChar(InfoArray, SizeOf(InfoArray), 0);
    {஢ ⮢}
    while (port[$1F7] and $80<>0) do ;
    { 뢠}
    port[$3f6] := 2;
    port[$1f6] := $A0 + ((count-1) shl 4);
    port[$1f7] := $EC;
    {஢ ⮢}
    while (port[$1F7] and $80<>0) do ;
    { ଠ}
    for i := 0 to 255 do InfoArray[i] := swap(portw[$1F0]);
    { ଠ}
    writeln('ଠ  䨧᪮ ᪥ ',count-1,^M^J);
    with IdeInfo do begin
      writeln(' ଠ஢ :', 9.5367431641E-7* {1/2^20}
        swap(BPT)*swap(CylsTotal)*swap(HeadTotal):5:0, 'Mb');
      writeln(' ଠ஢   :',
        longint(swap(SPT))*swap(CylsTotal)*swap(HeadTotal) div 2048:5, 'Mb');
      writeln('᫮ 樫஢           :', swap(CylsTotal):7);
      writeln('᫮              :', swap(HeadTotal):7);
      writeln('᫮ ᥪ஢  ஦ :', swap(SPT):7);
      writeln('᫮   ஦*    :', swap(BPT):7);
      writeln('᫮   ᥪ*     :', swap(BPS):7);
      writeln('              :', swap(BufSize):7);
      writeln(' ECC                   :', swap(ECC):7);
      writeln(' * -- ଠ஢ ', ^M^J);
      writeln('਩             :', serial);
      writeln('                    :',revision);
      writeln('                    :',model);
    end;
    write('H  ...');
{$IFDEF WINDOWS}
    readkey;
{$ELSE}
    asm xor ah,ah ; int 16h end;
{$ENDIF}
    writeln(^M^J);
  end;
end.

